import { renderless, api } from "@xmweb-ui/vue-renderless/user-head-group/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import UserHead from "@xmweb-ui/vue-user-head";
import { resolveComponent, openBlock, createElementBlock, normalizeStyle, normalizeClass, Fragment, createElementVNode, createVNode, renderList } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  components: {
    XmUserHead: UserHead
  },
  props: [].concat(props, ["groupSize", "list"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  class: "leading-[0] mb-px"
};
var _hoisted_2 = {
  class: "flex items-center justify-around"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_xm_user_head = resolveComponent("xm-user-head");
  return openBlock(), createElementBlock(
    "div",
    {
      style: normalizeStyle({
        "width": _ctx.groupSize * 2 + 2 + "px",
        "min-height": _ctx.groupSize * 2 + 2 + "px"
      }),
      class: normalizeClass([_ctx.state.list.length === 3 ? "block text-center" : "flex items-center justify-around flex-wrap"])
    },
    [_ctx.state.list.length === 3 ? (openBlock(), createElementBlock(
      Fragment,
      {
        key: 0
      },
      [createElementVNode("div", _hoisted_1, [createVNode(_component_xm_user_head, {
        round: _ctx.state.list[0].round,
        type: _ctx.state.list[0].type,
        modelValue: _ctx.state.list[0].modelValue,
        "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
          return _ctx.state.list[0].modelValue = $event;
        })
      }, null, 8, ["round", "type", "modelValue"])]), createElementVNode("div", _hoisted_2, [(openBlock(true), createElementBlock(
        Fragment,
        null,
        renderList(_ctx.state.list.slice(1, 3), function(item, i) {
          return openBlock(), createElementBlock("div", {
            key: i,
            class: "inline-block leading-[0]"
          }, [createVNode(_component_xm_user_head, {
            round: item.round,
            type: item.type,
            modelValue: item.modelValue,
            "onUpdate:modelValue": function onUpdateModelValue($event) {
              return item.modelValue = $event;
            }
          }, null, 8, ["round", "type", "modelValue", "onUpdate:modelValue"])]);
        }),
        128
        /* KEYED_FRAGMENT */
      ))])],
      64
      /* STABLE_FRAGMENT */
    )) : (openBlock(true), createElementBlock(
      Fragment,
      {
        key: 1
      },
      renderList(_ctx.state.list.slice(0, 4), function(item, i) {
        return openBlock(), createElementBlock("div", {
          key: i,
          class: "leading-[0]"
        }, [createVNode(_component_xm_user_head, {
          round: item.round,
          type: item.type,
          modelValue: item.modelValue,
          "onUpdate:modelValue": function onUpdateModelValue($event) {
            return item.modelValue = $event;
          }
        }, null, 8, ["round", "type", "modelValue", "onUpdate:modelValue"])]);
      }),
      128
      /* KEYED_FRAGMENT */
    ))],
    6
    /* CLASS, STYLE */
  );
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  mobileFirst as default
};
